=== debian/changelog ===
ros-kinetic-s3-file-uploader (1.0.1-1xenial) xenial; urgency=high

  * Address build error on ROS buildfarm (#135 <https://github.com/aws-robotics/rosbag-uploader-ros1/issues/135>)
    try to fix buildfarm build error and iterate on bloom release
  * Contributors: Miaofei Mei

 -- AWS RoboMaker <ros-contributions@amazon.com>  Wed, 01 Jul 2020 07:00:00 -0000
