=== debian/control ===
Source: ros-kinetic-s3-file-uploader
Section: misc
Priority: optional
Maintainer: AWS RoboMaker <ros-contributions@amazon.com>
Build-Depends: debhelper (>= 9.0.0), google-mock, libboost-all-dev, libgtest-dev, ros-kinetic-actionlib, ros-kinetic-actionlib-msgs, ros-kinetic-aws-common, ros-kinetic-aws-ros1-common, ros-kinetic-catkin, ros-kinetic-file-uploader-msgs, ros-kinetic-roscpp, ros-kinetic-rostest, ros-kinetic-s3-common
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-s3-file-uploader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-kinetic-actionlib, ros-kinetic-actionlib-msgs, ros-kinetic-aws-common, ros-kinetic-aws-ros1-common, ros-kinetic-file-uploader-msgs, ros-kinetic-roscpp, ros-kinetic-s3-common
Description: Package with a node that facilitates the uploading of files to Amazon S3
